#pragma once
#include "HttpFacade.h"
#include "IkXML.h"
#include "Observer.h"
#include "GTCommand.h"
#include "CommonType_Private.h"
#include "json.h"

class CWASActor;
class CActor;

class CWASCommand : protected _IHttpFacadeEvent, public IGTCommand
{
public:
	CWASCommand(CWASActor *pActor);
	virtual ~CWASCommand(void);

public:
	LPCWSTR GetErrorString()
	{
		return m_strWasErrMsg.c_str();
	}

	trid_t GetID()	{ return m_httpFacade.m_trid; }
	
	bool IsWorking(void) { return m_httpFacade.IsWorking(); }
	void SetTransactionID(trid_t trid) { m_httpFacade.m_trid = trid; }
	void CompleteCommand(void);
	void CancelCommand(void)
	{
		m_httpFacade.StopRequest();
		OnHttpCompleted(&m_httpFacade, false, true);
	}
    bool GetProgressInfo(size_t &totalSize, size_t &currentSize);
	
	
protected:	
	CHttpFacade		m_httpFacade;
	WSTRING	m_strWasErrMsg;
	WSTRING	m_strResultMsg;

	// Not used.. Always Async mode! protected mode!!!!
	virtual void Execute(void) { }

	virtual void OnWASActor_DeletedActor(CActor *pActor) { }

	// _IHttpFacadeEvent
	virtual void OnHttpProgress(CHttpFacade *pHttpF, DWORD dwTotalSize, DWORD dwCurrentSize) { }
	virtual void OnHttpCompleted(CHttpFacade *pHttpFacade, bool bSuccess, bool bCancel = false);

	bool LoadResponse();
	void CallWasResponse( bool bSuccess, CHttpFacade * pHttpFacade, std::string &strResultCode, NTWASResDataType resDataType, void *pResponseData );

	virtual void OnRequestTimeout(CHttpFacade *pHttpF, DWORD dwSeconds) { }

	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/)	{ }

	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		Json::Value * /*json*/)	{ }

private:
    void Call_OnWasResponse(trid_t trid, bool bSuccess, int nWinINetErrorCode, int nHttpResponseCode, LPCSTR szWasResCodeInHeader, LPCSTR szWasResCodeInXml, NTWASResDataType resDataType, void * pData);
	void SetErrorCode( int nCode );

protected:
	friend class CWASActor;

	GTWASCallErrorCode m_eError;
	int m_nWASError;
	GT_CACHE_SERIAL_DATA m_sCacheResult;
    P_GT_PENALTY_RESULT_DATA m_sPenaltyResultPrivate;
	std::string m_strResultXMLBuffer;
	CWASActor *m_pActor;
};
